#
# spec file for package ghc-countable
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name countable
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        1.0
Release:        6.1
Summary:        Countable, Searchable, Finite, Empty classes
License:        BSD-2-Clause
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
%if %{with tests}
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-silently-devel
BuildRequires:  ghc-tasty-devel
BuildRequires:  ghc-tasty-golden-devel
BuildRequires:  ghc-tasty-hunit-devel
%endif

%description
* 'class Countable', for countable types

* 'class AtLeastOneCountable', for countable types that have at least one value

* 'class InfiniteCountable', for infinite countable types

* 'class Searchable', for types that can be searched over. This turns out to
include some infinite types, see
<http://math.andrej.com/2007/09/28/seemingly-impossible-functional-programs/>.

* 'class Finite', for finite types

* 'class Empty', for empty types

* 'data Nothing', an empty type

Some orphan instances:

* '(Searchable a,Eq b) => Eq (a -> b)' / /

* '(Finite t) => Foldable ((->) t)' / /

* '(Finite a) => Traversable ((->) a)' / /

* '(Show a,Finite a,Show b) => Show (a -> b)' / /.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files

%changelog
* Thu Aug  3 2017 psimons@suse.com
- Updated with latest spec-cleaner version 0.9.8-8-geadfbbf.
* Thu Sep 15 2016 psimons@suse.com
- Update to version 1.0 revision 0 with cabal2obs.
